#include <bits/stdc++.h>
using namespace std;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m; cin >> n >> m;
    vector<vector<int>> neistomisljenici (n, vector<int> (m));
    for(int i=0; i<n; i++){
        for(int j=0; j<m; j++){
            int val; cin >> val;
            neistomisljenici[i][j] = val;
        }
    }
    vector<vector<pair<int64_t, int64_t>>> suma_neistomisljenika (n, vector<pair<int64_t, int64_t>> (m));
    // first-levo second-gore
    for(int i=1; i<n; i++){
        suma_neistomisljenika[i][1].first = neistomisljenici[i][0];
        suma_neistomisljenika[i][1].second = suma_neistomisljenika[i-1][1].second + neistomisljenici[i][1];
    }
    for(int j=1; j<m; j++){
        suma_neistomisljenika[1][j].second = neistomisljenici[j][0];
        suma_neistomisljenika[1][j].first = suma_neistomisljenika[j-1][1].first + neistomisljenici[1][j];
    }
    for(int i=2; i<n; i++){
        for(int j=2; j<m; j++){
            suma_neistomisljenika[i][j].first = suma_neistomisljenika[i][j-2].first + (int64_t)neistomisljenici[i][j-1];
            suma_neistomisljenika[i][j].second = suma_neistomisljenika[i-2][j].second + (int64_t)neistomisljenici[i-1][j];
        }
    }
    vector<vector<pair<int64_t, int64_t>>> ukupno_neistomisljenika (n, vector<pair<int64_t, int64_t>> (m));
    for(int i=1; i<n; i++){
        for(int j=1; j<m; j++){
            ukupno_neistomisljenika[i][j].first = ukupno_neistomisljenika[i][j-1].first + suma_neistomisljenika[i][j].first;
            ukupno_neistomisljenika[i][j].second = ukupno_neistomisljenika[i-1][j].second + suma_neistomisljenika[i][j].second;
        }
    }
    //9e18
    vector<vector<int64_t>> dp (n, vector<int64_t> (m));

    for(int i=1; i<n; i++){
        for(int j=1; j<m; j++){
            int64_t ans1 = dp[i][j-1] + ukupno_neistomisljenika[i][j].second;
            int64_t ans2 = dp[i-1][j] + ukupno_neistomisljenika[i][j].first;
            dp[i][j] = min(ans1, ans2);
        }
    }

    cout << dp[n-1][m-1] << '\n';

}